USE [WideWorldImporters];
GO

BULK INSERT Sales.OrderLines
FROM 'C:\SQLskills\24HOP\OrderLinesnew.txt'
WITH 
(
		DATAFILETYPE = 'native',
		TABLOCK
)

BULK INSERT Sales.Orders 
FROM 'C:\SQLskills\24HOP\OrdersNew.txt'
WITH 
(
		DATAFILETYPE = 'native',
		TABLOCK
)


USE [WideWorldImporters];
GO

INSERT INTO [Sales].[CustomerTransactions](
	[CustomerTransactionID], 
	[CustomerID],
	[TransactionTypeID],
	[InvoiceID],
	[PaymentMethodID],
	[TransactionDate], 
	[AmountExcludingTax],
	[TaxAmount],
	[TransactionAmount],
	[OutstandingBalance],
	[FinalizationDate],
	[LastEditedBy],
	[LastEditedWhen]
	)
SELECT 
	[CustomerTransactionID] + 385500, [CustomerID], 
	[TransactionTypeID], 1, [PaymentMethodID], 
	[TransactionDate], ([CustomerID] + 5) * 2, 
	(([CustomerID] + 5) * 2) * .05, 
	(([CustomerID] + 5) * 2) + ((([CustomerID] + 5) * 2) * .05), 
	[OutstandingBalance],[FinalizationDate],[LastEditedBy],
	[LastEditedWhen]
FROM [WideWorldImporters].[Sales].[CustomerTransactions] 
WHERE [AmountExcludingTax] = 0;

EXEC [Sales].[usp_GetFullProductInfo] 90 WITH RECOMPILE;
GO

EXEC [Sales].[usp_GetFullProductInfo] 224 WITH RECOMPILE;
GO


DBCC FREEPROCCACHE


EXEC [Sales].[usp_GetFullProductInfo] 90 WITH RECOMPILE;
GO

EXEC [Sales].[usp_GetFullProductInfo] 224 WITH RECOMPILE;
GO

EXEC [Sales].[usp_GetFullProductInfo] 220;
GO


DECLARE @StartDate1 DATE = '2017-01-01'
DECLARE @EndDate1 DATE = '2017-01-01'

EXEC [Sales].[usp_CustomerOrdersByDate] @StartDate1, @EndDate1

EXEC [Sales].[usp_CustomerTransactionInfo] 401;
GO


/*
	confirm plan
*/
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
GO
SELECT 
	[qs].execution_count, 
	[s].[text], 
	[qs].[query_hash], 
	[qs].[query_plan_hash], 
	[cp].[size_in_bytes]/1024 AS [PlanSizeKB], 
	[qp].[query_plan], 
	[qs].[plan_handle]
FROM sys.dm_exec_query_stats AS [qs]
CROSS APPLY sys.dm_exec_query_plan ([qs].[plan_handle]) AS [qp]
CROSS APPLY sys.dm_exec_sql_text([qs].[plan_handle]) AS [s]
INNER JOIN sys.dm_exec_cached_plans AS [cp] 
	ON [qs].[plan_handle] = [cp].[plan_handle]
WHERE [s].[text] LIKE '%CustomerOrdersByDate%';
GO
SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
GO

